#ifndef _Debug_h_
#define _Debug_h_
#include <fstream.h>

#include "config.h"
#include "Logger.h"
// Insert the following lines into your main app
//TRACE(ofstream ctrace("trace"));
//DEBUG(ofstream cdbg("debug"));
//int verbose=0
//int verbose_what=0

// Verbosity levels
// See logger.h

#ifdef ENABLE_DEBUG
extern Logger slog;
#define DEBUG(x) x
#define VERB(x) x
#define VERBLV(lv,x) if(lv<verbose) { x; }
#define VERBTY(w,x) if(verbose_what==w) { x; }
#else
#define DEBUG(x)
#define VERB(x)
#define VERBLV(lv,x)
#define VERBTY(w,x)
#endif

#ifdef ENABLE_ASSERTIONS
extern Logger slog;
#define ASSERT(x) x
#define ASSERT2(x)
#else
#define ASSERT(x)
#define ASSERT2(x)
#endif

#endif
